clear
%% Constantes physiques
Ta=20; % oC % temprature  gauche
Tb=-20; % oC % temprature  droite
k=100; % W/m.oC % conductivit thermique
f_source=0; % W/m^3 % terme source constant
L=0.04; % m % longueur de la tige

%% Paramtres du modle
nn=10; % nombre de noeuds
dx=L/(nn-1); %m % discrtisation en espace

%% Assemblage de la matrice A
A=[ 2 -1 0 ; 
    -1 2 -1 ;
    0 -1 2 ]
%% Assemblage du vecteur b
% terme source
f(2:4)=f_source;

b= [ (Ta+dx^2/k*f(2)) (dx^2/k*f(3)) (Tb+dx^2/k*f(4)) ]'

%% Rsolution du systme matriciel A{T}=b
T(2:4)=A\b;
T(1)=Ta;
T(5)=Tb;

%% Impression des rsultats  l'cran 
FigHandle = figure(1);
set(FigHandle, 'Position', [200, 200, 800, 600]);
plot(dx*[0:1:4],T,'b-')
hold on
plot(dx*[0:1:4],T,'ro','MarkerSize',18)
xlabel('x (m)','fontsize',16)
ylabel(['Temprature (' char(176) 'C)'],'fontsize',16)
title('Profil de temprature dans la tige','fontsize',16)
set(gca,'fontsize',14)