clear
%% Constantes physiques
Ta=20; % oC % temprature  gauche
Tb=-20; % oC % temprature  droite
Tinf=-20;
k=100; % W/m.oC % conductivit thermique
f_source=0; % W/m^3 % terme source constant
L=0.04; % m % longueur de la tige
hw=10000 ; %W/m^2.K

%% Paramtres du modle
nn=12; % nombre de noeuds
dx=L/(nn-1); %m % discrtisation en espace
gamma=-2*dx/k;

%% Assemblage de la matrice A (forme non-compacte)
A=zeros(nn,nn);
  
for i=2:1:nn-1,
    A(i,i-1)=-1;
    A(i,i)=2;
    A(i,i+1)=-1;
end

% conditions fontires
A(1,1)=1;
A(nn,nn-1)=-k/dx/hw;
A(nn,nn)=(k/dx+hw);

%% Assemblage du vecteur b (forme non-compacte)
b=zeros(nn,1);
% terme source
f(2:nn-1)=f_source;

for i=2:1:nn-1,
    b(i)=(dx^2/k*f(i));
end

% conditions fontires
b(1)=Ta;
b(nn)=Tinf;

%% Rsolution du systme matriciel A*{T}=b
T=A\b

%% Impression des rsultats  l'cran 
FigHandle = figure(1);
set(FigHandle, 'Position', [200, 200, 800, 600]);
plot(dx*[0:1:nn-1],T,'b-')
hold on
plot(dx*[0:1:nn-1],T,'rx','MarkerSize',18)
xlabel('x (m)','fontsize',16)
ylabel(['Temprature (' char(176) 'C)'],'fontsize',16)
title('Profil de temprature dans la tige','fontsize',16)
set(gca,'fontsize',14)