clear
%% Constantes physiques
To=20; % oC % temprature initiale
Tb=-20; % oC % temprature  droite
alpha=0.001; % m^2/s % diffusivit thermique
L=0.04; % m % longueur de la tige
Cst_NbCourant=0.49; % constante pour le nombre de Courant diffusif (par scurit  cause des erreurs d'arrondi on prend souvent 0.49 au lieu de 0.50, mme si dans ce programme 0.50 marche bien)
tend=3; % s % temps final

%% Paramtres du modle
nn=9; % nombre de noeuds
dx=L/(nn-1); %m % discrtisation en espace

%*****************************************
% Explicit scheme
%*****************************************
%Initialisation
T = zeros(nn,1);
T(:)=To;
T(end)=Tb;
x=0:dx:L;
%x = linspace(0,L,nn);

%% Impression des rsultats  l'cran 
FigHandle = figure(1);
set(FigHandle, 'Position', [200, 200, 800, 600]);
plot(x,T,'b-')
hold on
plot(x,T,'rx','MarkerSize',18)
xlabel('x (m)','fontsize',16)
ylabel(['Temprature (' char(176) 'C)'],'fontsize',16)
title('Profil de temprature dans la tige - Explicite','fontsize',16)
set(gca,'fontsize',14)
axis([0 L Tb To])
hold on

dt= dx^2/alpha * Cst_NbCourant;
fprintf('Value of dt is : %5.5g s',dt)
c= alpha * dt/dx^2;

for t=0:dt:tend,
%     T(1)=1/3*(4*T(2)-T(3));
    T(1)=To;
    
    % calcul non-vectoris
    Tn=T;
    for i=2:1:nn-1,
      T(i)=Tn(i) + c * (Tn(i-1) -2*Tn(i) + Tn(i+1));
    end
    
    % calcul vectoris (plus rapide  l'excution)
%     T(2:end-1)=T(2:end-1) + c * (T(1:end-2) -2*T(2:end-1) + T(3:end));
    
    if mod(t,dt*40)==0,
        plot(x,T,'b-')
        hold on
        plot(x,T,'rx','MarkerSize',18)
        pause(1)
    end
end

